using System;
using System.Collections.Generic;
using System.Text;

namespace _3_AggregationComposition
{
  public class Vehicle
  {
    // Aggregation uses instances of objects created outside of
    // this class
    protected Door FrontRight;
    protected Door FrontLeft;
    protected Door RearRight;
    protected Door RearLeft;

    // inner classes used to create objects that are intrinsically
    // linked to the class Car
    protected class Engine
    {
      public int horsePower;
    }

    protected class Battery
    {
      public int voltage;
    }

    // Composition uses instances of objects that are created as
    // part of this object
    protected Engine theEngine;
    protected Battery theBattery;

    public Vehicle()
    {
      theEngine = new Engine();
      theBattery = new Battery();
    }
  }

  public class Door
  {
    public int position;
  }  

  // Inherit from class Car
  public class FordCapri : Vehicle
  {
    public FordCapri()
    {
      theEngine.horsePower = 2000;
    }

    public int GetEngineSize()
    {
      return theEngine.horsePower;
    }
  }
}
